<?php
/*
Plugin Name: myWeather
Version: 2.4
Plugin URI: http://www.thedeveloperinside.com/blog/myweather-20-released
Author: Eduardo
Author URI: http://www.thedeveloperinside.com/
Description: Shows current weather conditions for mutliply cities from weather.com

 Contributors:
 ==============================================================================
 Developer              Eduardo      http://www.thedeveloperinside.com
 Developer              alpinism     http://www.erata.net
 Xml Parser				minixml  	 http://minixml.psychogenic.com

*/
$plugin_directory = get_option('home')."/wp-content/plugins/myweather/";
function set_cache($n,$d){
	$f=@fopen($n,"w");
	if (!$f) {
		return false;
	} else {
		fwrite($f,$d);
		fclose($f);
		return true;
	}
}

function search_file_cached($city,$wp_weather_xml){
	$plugin_directory=dirname(__FILE__)."/";
	$wp_weather_cache_temp=get_option('wp_weather_city_cache');
	$file=$city.".xml";
	$regexp="/(<!--date:)(.*)(-->)/";
	
	if(is_file($plugin_directory."cache/".$file)){
		$actualfile=file_get_contents($plugin_directory."cache/".$file);
		if(preg_match($regexp,$actualfile,$ext)){
			if(($ext[2]+$wp_weather_cache_temp)>time()){
				$xml=$actualfile;
			}else{
				$xml=preg_replace($regexp,"<!--date:".time()."-->",$actualfile);
				set_cache($plugin_directory."cache/".$file,$xml);
			}
		}
	}else{
		$xml=file_get_contents($wp_weather_xml);
		$xml.="<!--date:".time()."-->";
		set_cache($plugin_directory."cache/".$file,$xml);
	}
	return $xml;
}


function wp_myweather(){
	require_once(dirname(__FILE__).'/minixml/minixml.inc.php');
	global $plugin_directory;
	$citylist=get_option('wp_weather_city');
	if($citylist!=""){
		$citylist=explode("||",$citylist);
		
		foreach($citylist as $city){
			$t_type=get_option('wp_weather_city_temp');
			$usedtemplate=get_option('wp_weather_template');
			if(!$t_type){
				$t_type="C";
			}
			$fdata = "http://xoap.weather.com/weather/local/".$city."?cc=*&dayf=0";
		
			$file=search_file_cached($city,$fdata);
		
			$xmlObj = new MiniXMLDoc();
		
			$xmlObj->fromString($file);
			$xml = $xmlObj->getRoot();
	
			$template=array();
	
			$head = $xml->getElement('head');
			$locale = $head->getElement('locale');
	
			$template['locale']=$locale->getValue(); //lingua
		
			$form = $head->getElement('form');
		
			$template['form']=$form->getValue(); //formato
		
			$ut = $head->getElement('ut');
		
			$template['ut']=$ut->getValue(); //scala temperatura
		
			$ud = $head->getElement('ud');
		
			$template['ud']=$ud->getValue(); //scala distanza
		
			$us = $head->getElement('us');
		
			$template['us']=$us->getValue(); //scala velocita/tempo
		
			$up = $head->getElement('up');
		
			$template['up']=$up->getValue(); //scala pressione
		
			$ur = $head->getElement('ur');
		
			$template['ur']=$ur->getValue(); //
		
			$loc = $xml->getElement('loc');
			$dnam = $loc->getElement('dnam');	
		
			$template['city']=$dnam->getValue(); //nome citta
		
			$tm = $loc->getElement('tm');	
		
			$template['time']=$tm->getValue(); //orario
		
			$lat = $loc->getElement('lat');	
		
			$template['lat']=$lat->getValue(); //latitudine
		
			$lon = $loc->getElement('lon');	
		
			$template['lon']=$lon->getValue(); //longitudine
		
			$suns = $loc->getElement('suns');	
		
			$template['suns']=$suns->getValue(); //alba
		
			$sunr = $loc->getElement('sunr');	
		
			$template['sunr']=$sunr->getValue(); //tramonto
		
			$zone = $loc->getElement('zone');	
		
			$template['zone']=$zone->getValue(); //zona
		
			$cc = $xml->getElement('cc');
			$lsup = $cc->getElement('lsup');	
		
			$template['lsup']=$lsup->getValue(); //data rilevamento
		
			$obst = $cc->getElement('obst');	
		
			$template['obst']=$obst->getValue(); //osservatorio
		
			$tmp = $cc->getElement('tmp');	
		
			$template['tmp']=$tmp->getValue(); //temperatura
		
			$flik = $cc->getElement('flik');	
		
			$template['flik']=$flik->getValue(); //flik
		
			$t = $cc->getElement('t');	
		
			$template['weather']=$t->getValue(); //meteo
		
			$icon = $cc->getElement('icon');	
		
			$template['icon']=$icon->getValue(); //icona tempo
		
			$bar = $cc->getElement('bar');	
			$r = $bar->getElement('r');	
		
			$template['bar_r']=$r->getValue(); //pressione
	
			$bar = $cc->getElement('bar');	
			$d = $bar->getElement('d');	
		
			$template['bar_d']=$d->getValue(); //tipo pressione
	
			$wind = $cc->getElement('wind');
			$s = $wind->getElement('s');		
		
			$template['wind_s']=$s->getValue(); //velocità vento
	
			$wind = $cc->getElement('wind');
			$gust = $wind->getElement('gust');	
		
			$template['wind_gust']=$gust->getValue(); //raffica 
	
			$wind = $cc->getElement('wind');
			$d = $wind->getElement('d');	
		
			$template['wind_d']=$d->getValue(); //
	
			$wind = $cc->getElement('wind');
			$t = $wind->getElement('t');	
		
			$template['wind_t']=$t->getValue(); //direzione vento (N,S,E,W)
	
			$hmid = $cc->getElement('hmid');
		
			$template['hmid']=$hmid->getValue(); //umidità in %
	
			$vis = $cc->getElement('vis');
		
			$template['vis']=$vis->getValue(); //visibilità (distanza)
	
			$uv = $cc->getElement('uv');
			$i = $uv->getElement('i');	
		
			$template['uv_i']=$i->getValue(); // raggi uv
	
			$uv = $cc->getElement('uv');
			$t = $uv->getElement('t');	
		
			$template['uv_t']=$t->getValue(); // tipo raggi
	
			$dewp = $cc->getElement('dewp');
		
			$template['dewp']=$dewp->getValue(); //Punto di rugiada (in temp)
	
			$moon = $cc->getElement('moon');
			$icon = $moon->getElement('icon');	
		
			$template['moon_icon']=$icon->getValue(); //icona luna
	
			$moon = $cc->getElement('moon');
			$t = $moon->getElement('t');	
		
			$template['moon_t']=$t->getValue(); //tipo luna
		
			list($template['city'])=explode(",",$template['city']);
			list($template['city'])=explode("/",$template['city']);
		
			switch($t_type){
				default:
				case "F":
					$template['tmp']=$template['tmp']."&deg;";
					break;
				case "C":
					$template['tmp']=round(($template['tmp']-32)/(1.8))."&deg;";
					break;
			}
			switch($template['icon']){
			  default:
			  case 44:
					$icon=0;
					break;
			  case 5:
			  case 8:
			  case 9:
			  case 11:
					$icon=1;
					break;
			  case 15:
			  case 25:
					$icon=2;
					break;
			  case 20:
					$icon=3;
					break;
			  case 32:
			  case 36:
					$icon=4;
					break;
			  case 19:
			  case 21:
			  case 22:
					$icon=5;
					break;
			  case 0:
			  case 1:
			  case 2:
			  case 3:
			  case 4:
			  case 17:
			  case 35:
			  case 37:
			  case 38:
			  case 47:
					$icon=6;
					break;
			  case 39:
					$icon=7;
					break;
			  case 13:
					$icon=8;
					break;
			  case 23:
			  case 24:
					$icon=9;
					break;
			  case 14:
					$icon=10;
					break;
			  case 14:
			  case 16:
			  case 18:
			  case 41:
			  case 42:
			  case 43:
			  case 46:
					$icon=11;
					break;
			  case 10:
			  case 12:
			  case 40:
			  case 45:
					$icon=12;
					break;
			  case 26:
					$icon=13;
					break;
			  case 6:
			  case 7:
					$icon=14;
					break;
			  case 28:
			  case 30:
			  case 34:
					$icon=15;
					break;
			  case 27:
			  case 29:
			  case 31:
			  case 33:
					$icon=16;
					break;
			}
			
			
			$template['icon']=$plugin_directory .'templates/'.$usedtemplate.'/icon/'.$icon.'.gif';
			
			$loadfile=file_get_contents(dirname(__FILE__).'/templates/'.$usedtemplate.'/template.html');
			foreach($template as $key=>$value){
				$loadfile=str_replace('{'.strtoupper($key).'}',$value,$loadfile);
			
			}
			echo $loadfile;
		}
	}
}
function myweather_style() {
	global $plugin_directory;
	$usedtemplate=get_option('wp_weather_template');
	print('<link href="'.$plugin_directory.'templates/'.$usedtemplate.'/style.css" rel="stylesheet" type="text/css" />'."\n");
}
// Admin
function myweather_admin() {
	include("admin.myweather.php");
}
function myweather_to_admin() {
	if (function_exists('add_submenu_page')) {
		add_submenu_page('plugins.php', 'myWeather', 'myWeather', 10, basename(__FILE__), 'myweather_admin');
	}
}
add_action('admin_menu','myweather_to_admin');
add_action('wp_head', 'myweather_style', 10);

// widget
function widget_myweather_init() {
    if ( !function_exists('register_sidebar_widget') ){
            return;
    }
    register_sidebar_widget(array('myWeather', 'widgets'), 'widget_myweather');    
}

function widget_myweather($args){
    extract($args);
    echo $before_widget . $before_title . $title . $after_title;
    wp_myweather();
    echo $after_widget;
}
add_action('widgets_init', 'widget_myweather_init');

?>